<script lang="ts">
  import { authTokenParsed } from '$stores/authStore';
  import CreateTeam from '$lib/components/pages/user-dashboard/CreateTeam.svelte';
  import { GetInstitutionsStore } from '$houdini';
  import Alert from '$lib/components/ui-elements/Alert.svelte';
  import Spinner from '$lib/components/ui-elements/Spinner.svelte';
  import ExistingTeams from '$lib/components/pages/user-dashboard/ExistingTeams.svelte';
  import { discoverableTeams } from '$routes/(app)/user-dashboard/stores';
  import type { Institution } from '$lib/graphql/types';

  let institutions: Institution[] | undefined;
  let ready: Promise<unknown> = loadInstitutions();

  async function loadInstitutions() {
    let domain = $authTokenParsed!.email.split('@')[1];
    const userInstitutions = await new GetInstitutionsStore().fetch({
      variables: {
        domain: domain
      }
    });
    institutions = userInstitutions.data?.institutions;
  }
</script>

<div class="w-full">
  <section class="flex flex-col mx-5 2xl:mx-auto 2xl:w-2/3">
    {#await ready}
      <div class="w-full h-64">
        <div class="self-center mx-auto my-auto">
          <Spinner />
        </div>
      </div>
    {:then}
      <div class="flex flex-col">
        {#if !(institutions && institutions.length > 0)}
          <div role="alert" class="pt-2">
            <div class="bg-orange-500 text-white font-bold rounded-t px-4 py-2">Institution Not Found</div>
            <div class="border border-t-0 border-orange-400 rounded-b bg-orange-100 px-4 py-3">
              Your Institution could not be determined. Please reach out to
              <a href="mailto:support@c2games.org">support@c2games.org</a>
              with your Name, Institution/School Name, and Email Address.

              <br /><br />
              <b>Note:</b> The NCAE Cyber Games are only open to
              <a target="_blank" href="https://www.caecommunity.org/cae-map">CAE Schools</a>. This list may be out of
              date; if you believe your school is a CAE school and is not listed here, please contact
              <a href="mailto:support@c2games.org">support@c2games.org</a>.
            </div>
          </div>
        {:else}
          <ExistingTeams />
          {#if $discoverableTeams.data?.teams.length}
            <Alert color="yellow" class="mb-3">
              <div slot="title">Existing Teams</div>
              Some teams already exist from your institution; Additional Teams may be created, but with some limitations:
              <ul class="list-disc list-inside py-2">
                <li>All teams must meet eligibility criteria, including minimum number of participants</li>
                <li>Teams from the same institution must all participate on the same event date</li>
                <li>Teams from the same institution may not communicate or collaborate with each other in any way</li>
              </ul>
              Please see
              <a href="/rules">Team Composition section of the Rules</a>
              for more information.
            </Alert>
          {/if}
          <CreateTeam {institutions} />
        {/if}
      </div>
    {/await}
  </section>
</div>
